aboutsummaryrefslogtreecommitdiff
path: root/test/lint/commit-script-check.sh
diff options
context:
space:
mode:
authorMarcoFalke <falke.marco@gmail.com>2018-05-19 10:27:54 -0400
committerMarcoFalke <falke.marco@gmail.com>2018-05-24 12:02:15 -0400
commitfa3c910bfeab00703c947c5200a64c21225b50ef (patch)
tree6d8e8ad2d248c22fece1f5c1bebd6cf9ace38db0 /test/lint/commit-script-check.sh
parentd9ebb63919fb311ace0ae977e3183ccb80ed7d3c (diff)
downloadbitcoin-fa3c910bfeab00703c947c5200a64c21225b50ef.tar.xz
test: Move linters to test/lint, add readme
Diffstat (limited to 'test/lint/commit-script-check.sh')
-rwxr-xr-xtest/lint/commit-script-check.sh46
1 files changed, 46 insertions, 0 deletions
diff --git a/test/lint/commit-script-check.sh b/test/lint/commit-script-check.sh
new file mode 100755
index 0000000000..1c9dbc7f68
--- /dev/null
+++ b/test/lint/commit-script-check.sh
@@ -0,0 +1,46 @@
+#!/bin/sh
+# Copyright (c) 2017 The Bitcoin Core developers
+# Distributed under the MIT software license, see the accompanying
+# file COPYING or http://www.opensource.org/licenses/mit-license.php.
+
+# This simple script checks for commits beginning with: scripted-diff:
+# If found, looks for a script between the lines -BEGIN VERIFY SCRIPT- and
+# -END VERIFY SCRIPT-. If no ending is found, it reads until the end of the
+# commit message.
+
+# The resulting script should exactly transform the previous commit into the current
+# one. Any remaining diff signals an error.
+
+if test "x$1" = "x"; then
+ echo "Usage: $0 <commit>..."
+ exit 1
+fi
+
+RET=0
+PREV_BRANCH=`git name-rev --name-only HEAD`
+PREV_HEAD=`git rev-parse HEAD`
+for i in `git rev-list --reverse $1`; do
+ if git rev-list -n 1 --pretty="%s" $i | grep -q "^scripted-diff:"; then
+ git checkout --quiet $i^ || exit
+ SCRIPT="`git rev-list --format=%b -n1 $i | sed '/^-BEGIN VERIFY SCRIPT-$/,/^-END VERIFY SCRIPT-$/{//!b};d'`"
+ if test "x$SCRIPT" = "x"; then
+ echo "Error: missing script for: $i"
+ echo "Failed"
+ RET=1
+ else
+ echo "Running script for: $i"
+ echo "$SCRIPT"
+ eval "$SCRIPT"
+ git --no-pager diff --exit-code $i && echo "OK" || (echo "Failed"; false) || RET=1
+ fi
+ git reset --quiet --hard HEAD
+ else
+ if git rev-list "--format=%b" -n1 $i | grep -q '^-\(BEGIN\|END\)[ a-zA-Z]*-$'; then
+ echo "Error: script block marker but no scripted-diff in title"
+ echo "Failed"
+ RET=1
+ fi
+ fi
+done
+git checkout --quiet $PREV_BRANCH 2>/dev/null || git checkout --quiet $PREV_HEAD
+exit $RET